import { EquipmentSlot, ItemStack, world, GameMode, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:stand_cosplays", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.0, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:stand_cosplays,r=1] run summon furnicraft:stand_cosplays ~ ~-0.8 ~ ~0`)
                    break;
                case 'south':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:stand_cosplays,r=1] run summon furnicraft:stand_cosplays ~ ~-0.8 ~ ~180`)
                    break;
                case 'east':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:stand_cosplays,r=1] run summon furnicraft:stand_cosplays ~ ~-0.8 ~ ~90`)
                    break;
                case 'west':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:stand_cosplays,r=1] run summon furnicraft:stand_cosplays ~ ~-0.8 ~ ~270`)
                    break;
            }

        },
    });
});