import { EquipmentSlot, ItemStack, world, GameMode, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:fridge_place", {
        onPlace: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`structure load mystructure:fridge_double ~-1~~ 180_degrees`)
                    break;
                case 'south':
                    chairEntity.runCommand(`structure load mystructure:fridge_double ~~~ 0_degrees`)
                    break;
                case 'east':
                    chairEntity.runCommand(`structure load mystructure:fridge_double ~~~-1 270_degrees`)
                    break;
                case 'west':
                    chairEntity.runCommand(`structure load mystructure:fridge_double ~~~ 90_degrees`)
                    break;
            }

        },
    });
});

//ticking 6,6