import { EquipmentSlot, ItemStack, world, GameMode, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:toys_pose1", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",1))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:toys_pose2", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",2))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:toys_pose3", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",3))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:toys_pose4", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",4))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:toys_pose5", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",5))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:toys_pose6", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",6))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:toys_pose7", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",7))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:toys_pose8", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",8))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:toys_pose9", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",9))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:toys_pose10", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",10))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:toys_pose11", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",11))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:toys_pose12", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",12))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:toys_pose13", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",13))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:toys_pose14", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",14))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:toys_pose15", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",15))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:toys_pose16", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",16))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//ticking 6,6