import { world, GameMode, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:clock_1", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",1))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",1))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",1))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",1))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:clock_2", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",2))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",2))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",2))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",2))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:clock_3", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",3))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",3))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",3))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",3))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:clock_4", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",4))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",4))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",4))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",4))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:clock_5", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",5))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",5))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",5))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",5))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:clock_6", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",6))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",6))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",6))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",6))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:clock_7", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",7))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",7))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",7))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",7))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:clock_8", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",8))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",8))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",8))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",8))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:clock_9", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",9))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",9))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",9))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",9))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:clock_10", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",10))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",10))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",10))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",10))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:clock_11", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",11))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",11))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",11))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",11))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:clock_12", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",12))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",12))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",12))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",12))
                    furniEntity.runCommand(`playsound clock.on @a[r=10] ~ ~ ~ 1 1`)
                    break;
            }
        },
    });
});

//ticking 6,6